/*
Version 0.0.3 (06.11.2002) 
  Ecriture des noms de fichiers en majuscule, pour viter que les systme FAT32
  ne se plaignent lors de la copie de deux fichiers nomms foo et Foo !
  Ds lors les fichiers seront copis comme FOO, et le mcanisme de sauvegarde 
  dans un autre rpertoire sera mis  contribution. (option --fat32 ou -c)
*/


#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <utime.h>
#include <ctype.h>

#include "coupe.h"

char *prog_name;

int cp(char *nomfichier, char *nomfichier2, Options opt)
{
  // Copie nomfichier vers nomfichier2 si possible

  FILE *fp;
  FILE *fp2;
  int filedes;
  struct stat *buf;
  struct utimbuf *buf_time;
  int lus;
  int val;
  char *buffer;

  val = TRUE;
  buffer = (char*) malloc (sizeof(char)*TAILLE_BUFFER);
  buf_time = (struct utimbuf *) malloc (sizeof(struct utimbuf));

  if ((fp=fopen(nomfichier,"r"))!=NULL) // Si on peux ouvrir le fichier
    {
      buf = (struct stat*) malloc (sizeof(struct stat));
      filedes=fileno(fp);
      fstat(filedes,buf);
      if (S_ISREG(buf->st_mode))
	{
	  // vrification de l'existence du fichier !
	  if ((fp2=fopen(nomfichier2,"r"))!=NULL)
	    {
	      val = EXISTE;
	      if (opt.debug == TRUE)
		fprintf(stdout,"cp - Le fichier %s existe dj.\n",nomfichier2);
	      fclose(fp2);
	    }
	  else
	    {
	      if ((fp2=fopen(nomfichier2,"w"))!=NULL)
		{
		  while (!feof(fp))
		    {
		      lus = fread(buffer,1,TAILLE_BUFFER,fp);
		      fwrite(buffer,1,lus,fp2);
		    }
		  fclose(fp2);
		  buf_time->actime = buf->st_atime;
		  buf_time->modtime = buf->st_mtime;
		  utime(nomfichier2,buf_time);
		}
	      else
		{
		  val = ERREUR;
		  if (opt.debug == TRUE)
		    fprintf(stdout,"cp - Erreur lors de l'ouverture du fichier %s.\n",nomfichier2);
		}
	    }
	}
      else
	{
	  val = ERREUR;
	  if (opt.debug == TRUE)
	    fprintf(stdout,"cp - Le fichier %s n'est pas un fichier normal (%d)!\n",nomfichier,buf->st_mode);
	}
      fclose(fp);
    }
  else
    {
      val = ERREUR;
      if (opt.debug == TRUE)
	fprintf(stdout,"cp - Erreur lors de l'ouverture du fichier %s.\n",nomfichier);
    }
  return val;
}


int cp_existe(char *nomfichier,char *nomfichier2, Options opt,int *nb)
{
  // Nom du fichier  copier (avec le rpertoire complet),
  // Nom du fichier sans le rpertoire,
  // Options du programme,
  // Calculs du nb de fichier par rpertoire.
  
  int j;
  int val;
  char *nomfinal;
  j=0;

  while (j<(MAXREP-1) && nb[j+1]>opt.lignes)
    j++;

  nomfinal = (char*) malloc (sizeof(char)*MAX_FILENAME);
  sprintf(nomfinal,"%s/a%d/%c",opt.destination,j,'\0');
  mkdir(nomfinal,493);
  sprintf(nomfinal,"%s/a%d/%s%c",opt.destination,j,nomfichier2,'\0');
  while ((val = cp(nomfichier,nomfinal,opt)) == EXISTE)
    {
      j++;
      while (j<(MAXREP-1) && nb[j+1]>opt.lignes)
	j++;
      sprintf(nomfinal,"%s/a%d/%c",opt.destination,j,'\0');
      mkdir(nomfinal,493);
      sprintf(nomfinal,"%s/a%d/%s%c",opt.destination,j,nomfichier2,'\0');
    }
  nb[j+1]++;
  free(nomfinal);
  return val;

}




int do_copie(FILE *fp,Options opt)
{
  char *nomfichier;    // Le nom du fichier en cours (issu de la liste)
  char *nomrepertoire; // Le nom du rpertoire en cours
  char *nomfichier2;   // Le nom du fichier de destination
  char c[2];
  int i;  // Pour compter le nombre de caractres dans le nom du fichier;
  int nb[MAXREP+1]; // Pour connaitre le nombre de fichiers traits
  int j;  // Pour connaitre le numro du rpertoire;
  int nbcar;
  int txtlong;
  int val;
  int totalite;
  int erreurs;

  // Initialisations
  totalite = 0;
  for (i=0;i<MAXREP;i++)
    nb[i] = 0;
  i = 0;
  j = -1; // Comme ca on commence  0 !!
  erreurs = 0; // tout du moins au dbut !!!

  if (opt.debug == TRUE)
    fprintf(stdout,"Ok.\nListing is %s and destination directory is %s\n",opt.filename,opt.destination);

  nomfichier = (char*) malloc (sizeof(char)*MAX_FILENAME);
  nomrepertoire = (char*) malloc (sizeof(char)*MAX_FILENAME);
  nomfichier2 = (char *) malloc (sizeof(char)*(MAX_FILENAME));

  while (!feof(fp))
    {
      // lecture des donnes de type find -print0
      fread(c,sizeof(char),1,fp);
      i=0;
      while (!feof(fp) && c[0]!='\0')
	{
	  nomfichier[i]=c[0];
	  i++;
	  fread(c,sizeof(char),1,fp);
	}
      nomfichier[i]='\0';
      // fin de cette lecture (on a un nom de fichier a copier)
      
      if (nb[0] == 0)
	{// Cration du rpertoire pour stocker les fichiers
	  j++;
	  sprintf(nomrepertoire,"%s/%d/",opt.destination,j);
	  mkdir(nomrepertoire,493);
	}
           
      // extraction du nom du fichier
      txtlong = strlen(nomfichier);
      nbcar = txtlong;
      while (nomfichier[nbcar]!='/') 
	{
	  nbcar--;
	}
      nbcar++;
      
      if (opt.fat32 == TRUE)
	{ // compatibilt fat32 (mise en majuscule)
	  i=0;
	  while (nbcar<txtlong && i<255)
	    {
	      nomfichier2[i] = toupper(nomfichier[nbcar]);
	      i++;
	      nbcar++;
	    }
	}
      else
	{
	  i=0;
	  while (nbcar<txtlong && i<MAX_FILENAME)
	    {
	      nomfichier2[i] = nomfichier[nbcar];
	      i++;
	      nbcar++;
	    }
	}

      nomfichier2[i] = '\0';
      sprintf(nomrepertoire,"%s/%d/%s%c",opt.destination,j,nomfichier2,'\0');
      if (opt.debug == TRUE || opt.text == TRUE)
	fprintf(stdout,"%d : %s --> %s (%s)\n",nb[0],nomfichier,nomrepertoire,nomfichier2);
      
      val = cp(nomfichier,nomrepertoire,opt); 

      if (val == EXISTE)
	{
	  val = cp_existe(nomfichier,nomfichier2,opt,nb);
	}
      else
	{
	  if (val == ERREUR && opt.erreur == TRUE)
	    {
	      fprintf(stdout,"%s\n",nomfichier);
	      erreurs++;
	    }
	  else
	    nb[0]++;
	    
	}
      if (nb[0] == (opt.lignes))
	nb[0] = 0;
      
	
    }
  for (i=0;i<MAXREP;i++)
    totalite += nb[i];

  totalite += (j*opt.lignes);

  if (opt.debug == TRUE)
    fprintf(stdout,"%d Fichiers Copis et %d erreur(s).\n",totalite,erreurs);
  free(nomrepertoire);
  free(nomfichier2);			 
  free(nomfichier);
  return TRUE;
}



void version()
{
  fprintf(stdout,"%s, %s - %s - Version %s\n",prog_name,Auteur,Date,Version);  
}

int usage(int status)
{
 if (status != 0)
    {
      fprintf (stderr, 
	       "Pour en savoir davantage, faites: `%s --help'\n",prog_name);
    }
  else
    {
      version();
      fprintf(stdout,"\
Permet de copier les fichiers d'une liste dans plusieurs rpertoires.\n\
Le fichier de liste (FICHIER) doit tre de la forme -print0 de la commande find\n");
      fprintf(stdout,"\nUsage : \n\
  %s [options] FICHIER Destination\n",prog_name);
      fprintf(stdout,"\nOptions :\n\
  -h, --help\tCette aide.\n\
  -v, --version\tAffiche la version du programme.\n\
  -f, --files=NBFILES\tFixe le nombre de fichiers pour chaque rpertoire.\n\
  -t, --text\tDonne le nom du fichier en cours de copie.\n\
  -c, --fat32\tPermet la compatibilit des noms avec le systme de fichiers FAT32\n\
  -e, --errors\tAffiche les erreurs rencontres\n\
  -d, --debug\tAffiche les messages permettant un ventuel dbuggage\n\
  ");
      fprintf(stdout,"\nSorties :\n\
  Les fichiers dans des rpertoires Destination/0, Destination/1 ...\n");
    }
  return TRUE;
}


int main (int argc, char ** argv)
{
  
  Options opt;

  FILE *fp,*fp2;
  int filedes;
  int filedes2;
  struct stat *buf;
  struct stat *buf2;
  int c;
  
  int help;
  int val;

  // Initialisations des paramtres
  opt.lignes = DEFLIGNES;  // nombre de lignes par dfaut (pour les sous listes)
  opt.filename = NULL;     // Nom du fichier de la liste principale
  opt.debug = FALSE;       // Par dfaut on debug pas !
  opt.erreur = FALSE;      // Par dfaut on n'affiche pas les erreurs
  opt.fat32 = FALSE;
  opt.text = FALSE;

  val = TRUE;   // Valeur de retour du programme
  help = FALSE; // Aide, non demande par dfaut (--help)
  c = 0;        // Nombre de paramtres de la ligne de commande

  prog_name = (char*) malloc (sizeof(char)*256);
  prog_name = argv[0];

  while ((c = getopt_long (argc, argv, "vhdeftc", long_options, NULL)) != -1)
    {
      switch (c)
	{
	case 0:			/* Long option. */
	  break;
	  
	case 'v':
	  version();
	  break;
	 
	case 'h':
	  help = TRUE; 
	  break;
	
	case 'd':
	  opt.debug = TRUE; 
	  break;

	case 'e':
	  opt.erreur = TRUE; 
	  break;
	  
	case 't':
	  opt.text = TRUE; 
	  break;

	case 'c':
	  opt.fat32 = TRUE; 
	  break;

	case 'f':
	  if (optarg)
	    {
	      if (sscanf(optarg,"%d",&opt.lignes)<1)
		opt.lignes = DEFLIGNES;
	    }
	  else
	    opt.lignes = DEFLIGNES;
	  break;

	default:
	  usage(1);
	}
    }

 // les arguments qui ne sont pas dans ceux dfinis :
  if (optind < argc)
    {
	  opt.filename = (char*) malloc (sizeof(char)*strlen(argv[optind])+1);
	  strcpy(opt.filename,argv[optind]);
	  optind++;
	  
	  opt.destination = (char*) malloc (sizeof(char)*strlen(argv[optind])+1);
	  strcpy(opt.destination,argv[optind]);
	  optind++;

	  if ((fp=fopen(opt.filename,"r"))!=NULL) // Si on peux ouvrir le fichier
	    {
	      buf = (struct stat*) malloc (sizeof(struct stat));
	      filedes=fileno(fp);
	      fstat(filedes,buf);
	      if (S_ISREG(buf->st_mode))  // Si il s'agit d'un fichier normal
		{// vrification que Destination est bien un rpertoire
		  if ((fp2=fopen(opt.destination,"r"))!=NULL)
		    {
		      buf2 = (struct stat*) malloc (sizeof(struct stat));
		      filedes2 = fileno(fp2);
		      fstat(filedes2,buf2);
		      if (S_ISDIR(buf2->st_mode))
			{// on fait le traitement
			  val = do_copie(fp,opt);
			}
		      else
			{
			  if (opt.erreur == TRUE)
			    fprintf(stdout,"main - La destination n'est pas un rpertoire.\n");
			  val = ERREUR;
			}
		      free(buf2);
		      fclose(fp2);
		    }
		  else
		    {
		      if (opt.erreur == TRUE)
			fprintf(stdout,"main - Erreur lors de l'ouverture du fichier %s.\n",opt.destination);
		      val = ERREUR;
		    }
		}
	      else
		{
		  if (opt.erreur == TRUE)
		    fprintf(stdout,"main - Le Fichier %s n'est pas un fichier ordinaire.\n",opt.filename);
		  val = ERREUR;
		}
	      free(buf);
	      fclose(fp);
	    }
	  else
	    {
	      if (opt.erreur == TRUE)
		fprintf(stdout,"main - Erreur lors de l'ouverture du fichier %s.\n",opt.filename);
	      val = ERREUR;
	    }
	  free(opt.filename);	
    }
  else
    {
      if (help == TRUE)
	usage(0);
    }

  free(prog_name);
  return val;
}
